SystemOrganization addCategory: #'Pier-Jetsam'!

!WAGlobalConfiguration class methodsFor: '*pier-jetsam-override' stamp: 'kph 8/17/2007 08:04'!
setDeploymentMode
	DeploymentMode := true.
	
	Preferences allPreferenceObjects do: [ :each | 
		
		(each categoryList includes: PRDebugging category) ifTrue: [ each restoreDefaultValue  ]
		
	].! !

!PRContentsWidget methodsFor: '*pier-jetsam-override' stamp: 'kph 11/30/2007 19:01'!
buildComponent: aContext
	^ aContext command asComponent
		onAnswer: [ :value | self onAnswerCommand: (aContext command onReturn: value) ];
		yourself! !

!PRContentsWidget methodsFor: '*pier-jetsam-override' stamp: 'kph 8/19/2007 04:14'!
onAnswerCommand: aCommand
	aCommand isNil
		ifTrue: [ ^ self context: (self context structure: self context structure) ].
	[ aCommand execute ]
		on: Error
		do: [ :err | 
			 
			Preferences debugPierFormErrors ifTrue: [ err pass ].
			
			^ self component errors add: err.  ].
	self context: aCommand answer! !

!Object methodsFor: '*pier-jetsam' stamp: 'kph 8/17/2007 07:36'!
helpfulError: msg

	Preferences helpfulErrors ifTrue: [ self error: msg ].! !

Object subclass: #PRDebugging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam'!

!PRDebugging class methodsFor: 'as yet unclassified' stamp: 'kph 10/4/2007 15:05'!
initialize
 
	Preferences addBooleanPreference: #helpfulErrors categories: self categories default: false balloonHelp: 'Enable helpful errors. (See senders of #helpfulError:)'.
		
	Preferences addBooleanPreference: #haltOnForbidden categories:  self categories default: false balloonHelp: 'Halt when user accesses a forbidden page'.
	
	Preferences addBooleanPreference: #haltOnDbCommit categories:  self categories default: false balloonHelp: 'Halt when write is made to database (if you have one)'. 
	
	Preferences addBooleanPreference: #debugInvalidLogin categories:  self categories default: false balloonHelp: 'Halt when pier login is invalid'.
	
	Preferences addBooleanPreference: #debugPierFormErrors categories:  self categories default: false balloonHelp: 'Halt when pier form validaton error occurs'.
	
	Preferences addBooleanPreference: #dbLogEveryRowReturned categories:  self categories default: false balloonHelp: 'Log everything returned from a db query'.

	Preferences addBooleanPreference: #ignoreKindValidation categories:  self categories default: false balloonHelp: 'Ignore Magritte Kind Validation'.

! !

!PRDebugging class methodsFor: 'as yet unclassified' stamp: 'kph 8/17/2007 07:57'!
categories

	^ #( #'seaside debug' )! !

!PRCommand methodsFor: '*pier-jetsam-override' stamp: 'kph 10/26/2007 17:44'!
execute
	"Execute the command of the receiver. To implement your action in the code of one of my subclasses. Never override this message, but instead have a look at the different template methods (==#doValidate==, ==#doExecute==, ==#doAnswer==) available in the events protocol."

	self log info execute: self.
	
	self assert: self context command == self.
	self isView
		ifTrue: [ self shouldNotImplement ].
	self timestamp: TimeStamp now.
	self kernel persistency
		execute: self.
	self doAnswer! !

!PRCommand methodsFor: '*pier-jetsam' stamp: 'kph 11/30/2007 18:59'!
onReturn: aComponentReturnValue

	^ aComponentReturnValue! !

!PRCommand methodsFor: '*pier-jetsam-override' stamp: 'kph 9/27/2007 22:43'!
printOn: stream

	super printOn: stream.
	stream << $( << self structure printString << $).
	
 ! !

!MAMultipleOptionDescription methodsFor: '*pier-jetsam-override' stamp: 'kph 10/4/2007 15:06'!
validateKind: anObject
 Preferences ignoreKindValidation ifTrue: [ self log warn: 'Kind Validation Ignored'. ^ self  ].
	super validateKind: anObject.
	(anObject allSatisfy: [ :each | self options includes: each ])
		ifFalse: [ MAKindError description: self signal: self kindErrorMessage ]! !

!PRPierFrame methodsFor: '*pier-jetsam-override' stamp: 'kph 10/22/2007 17:08'!
forbiddenRequest: aRequest

	Preferences haltOnForbidden  ifTrue: [ self halt ].

	 self session returnResponse: (WAResponse forbidden: aRequest url)! !

!PRPierMain methodsFor: '*pier-jetsam-override' stamp: 'kph 8/22/2007 23:00'!
forbidden: aRequest

	| page command |
	
	Preferences haltOnForbidden  ifTrue: [ self halt ].

	"self return: (WAResponse forbidden: aRequest url)"

	self context: (PRContext kernel: self kernel).

	page :=	PRPathLookup
		start: self kernel root path: '/site/access+denied'
		onError: [ self notFound: aRequest ].
		

	PRCurrentContext use: self during: [
		command :=	 page defaultCommandClass  new
			setContext: self context;
			initialRequest: aRequest;
			yourself.
			
		self context
			setStructure: page;
			setCommand: command.
		self context isValid
			ifFalse: [ self halt. self return: (WAResponse forbidden: aRequest url) ] ].

	super start: aRequest! !

!MADescription methodsFor: '*pier-jetsam-override' stamp: 'kph 9/13/2007 23:13'!
conflictErrorMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #conflictErrorMessage ifAbsent: [ 'Input is conflicting with concurrent modification' ]! !

!MADescription methodsFor: '*pier-jetsam-override' stamp: 'kph 8/19/2007 02:55'!
kindErrorMessage

 
   Preferences debugPierFormErrors ifTrue: [ self halt ].
	^ self propertyAt: #kindErrorMessage ifAbsent: [ 'Invalid input given' ]! !

!MADescription methodsFor: '*pier-jetsam-override' stamp: 'kph 9/13/2007 23:14'!
multipleErrorsMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #multipleErrorsMessage ifAbsent: [ 'Multiple errors' ]! !

!MADescription methodsFor: '*pier-jetsam-override' stamp: 'kph 9/13/2007 23:14'!
requiredErrorMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #requiredErrorMessage ifAbsent: [ 'Input is required but no input given' ]! !
PRDebugging initialize!
